#include <Arduino.h>
#include <SPI.h>
#include <oled_SSD1309_9Bit.h>  //use the OLED128 module with 9 bit SPI = 3 wire mode (no Data/Command line)
#include <font_16x32nums.h>
#include <font_6x8.h>
#include <font_8x16.h>
#include <font_8x8.h>
#include <logo_BLH.h>

/*Available functions in oled_SSD1309 Libraray:
  void initialize  (byte p_cs, byte p_si, byte p_clk, byte p_a0, byte p_res, byte type);
  void clear       (void);
  void contrast    (byte contr);
  void view        (byte direction);
  void string      (byte column, byte page, const byte *font_adress, const char *str);
  void rectangle   (byte start_column, byte start_page, byte end_column, byte end_page, byte pattern);
  void picture     (byte column, byte page, const byte *pic_adress);
*/

oled_SSD1309 OLED;



void sample_screen(void);

//initialize the backlight and the display
void setup()
{
  OLED.initialize(10,11,13,4,OLEDL128);   //SS = 10, 11 = MOSI, 13 = CLK 4 = RESET, EA OLED128-6 (=128x64 dots)
}

//create a sample sceen content
void sample_screen(void)
{
  OLED.clear();  //clear whole display
  OLED.picture(0,0,ea_logo);
  OLED.string(71,0,font_8x16,"OLED128");      //font size 8x16 first page         
  OLED.rectangle(71,2,127,2,0x03);              //show small line (filled pattern = 0x03), to the left and right of 'DOGM128'            
  OLED.string(0,3,font_6x8,"-3.3V single supply");
  OLED.string(0,4,font_6x8,"-SSD1309 controller");
  OLED.string(0,5,font_6x8,"-different backlights");
  OLED.string(0,6,font_6x8,"-extrem low power");
  OLED.string(0,7,font_8x8,"lcd-module.com");
}

//main loop
void loop()
{
  OLED.view(VIEW_BOTTOM);  //default viewing direction
  sample_screen();        //show content
  delay(2000);
  OLED.view(VIEW_TOP);    //alternate viewing direction
  sample_screen();
  delay(2000);
}
